Loading...
Searching...
No Matches
casacore::UnaryParam< T > Class Template Reference
Functionals_module_internal_classes

More...

`#include <UnaryParam.h>`

## Public Types

enum | { HEIGHT , CENTER , WIDTH }
| Parameter numbers. More...
Public Types inherited from casacore::Function< T, U >
typedef FunctionTraits< T >::ArgType | ArgType
typedef const ArgType * | FunctionArg

## Public Member Functions

| UnaryParam ()
| Constructs the Unary, Defaults: height=1, center=0, width=1.
| UnaryParam (const T &height)
| UnaryParam (const T &height, const T &center)
| UnaryParam (const T &height, const T &center, const T &width)
| UnaryParam (const UnaryParam< T > &other)
| Copy constructor (deep copy).
template<class W>
| UnaryParam (const UnaryParam< W > &other)
UnaryParam< T > & | operator= (const UnaryParam< T > &other)
| Copy assignment (deep copy).
virtual | ~UnaryParam ()
| Destructor.
virtual uInt | ndim () const
| Returns the number of dimensions of function.
virtual const String & | name () const
| Give name of function.
Public Member Functions inherited from casacore::Function< T, U >
| Function ()
| Constructors.
| Function (const uInt n)
| Function (const Vector< T > &in)
| Function (const FunctionParam< T > &other)
template<class W, class X>
| Function (const Function< W, X > &other)
virtual | ~Function ()
| Destructor.
uInt | nparameters () const
| Returns the number of parameters.
virtual U | eval (FunctionArg x) const =0
| Evaluate the function object.
T & | operator[] (const uInt n)
| Manipulate the nth parameter (0-based) with no index check.
const T & | operator[] (const uInt n) const
virtual U | operator() () const
| Evaluate this function object at xor at x, y.
virtual U | operator() (const ArgType &x) const
virtual U | operator() (const Vector< ArgType > &x) const
virtual U | operator() (FunctionArg x) const
virtual U | operator() (const ArgType &x, const ArgType &y) const
virtual U | operator() (const ArgType &x, const ArgType &y, const ArgType &z) const
Bool & | mask (const uInt n)
| Manipulate the mask associated with the nth parameter (e.g.
const Bool & | mask (const uInt n) const
const FunctionParam< T > & | parameters () const
| Return the parameter interface.
FunctionParam< T > & | parameters ()
const Vector< ArgType > & | argp () const
| Get arg_p and parset_p.
Bool | parsetp () const
void | lockParam ()
| Compiler cannot always find the correct 'const' version of parameter access.
void | unlockParam ()
virtual void | setMode (const RecordInterface &mode)
| get/set the function mode.
virtual void | getMode (RecordInterface &mode) const
virtual Bool | hasMode () const
| return True if the implementing function supports a mode.
ostream & | print (ostream &os) const
| Print the function (i.e.
virtual Function< T, U > * | clone () const =0
| Return a copy of this object from the heap.
virtual Function< typename FunctionTraits< T >::DiffType > * | cloneAD () const
virtual Function< typename FunctionTraits< T >::BaseType > * | cloneNonAD () const
Public Member Functions inherited from casacore::Functional< FunctionTraits< T >::ArgType, T >
virtual | ~Functional ()
| Destructor.
virtual T | operator() (const FunctionTraits< T >::ArgType &x) const=0
| Map a Domain x into a Range y value.
Public Member Functions inherited from casacore::Functional< Vector< FunctionTraits< T >::ArgType >, T >
virtual | ~Functional ()
| Destructor.
virtual T | operator() (const Vector< FunctionTraits< T >::ArgType > &x) const=0
| Map a Domain x into a Range y value.

## Additional Inherited Members

Protected Attributes inherited from casacore::Function< T, U >
FunctionParam< T > | param_p
| The parameters and masks.
Vector< ArgType > | arg_p
| Aid for non-contiguous argument storage.
Bool | parset_p
| Indicate parameter written.
Bool | locked_p
| Indicate that parameters are expected to be locked from changing.

## Detailed Description

template<class T>
class casacore::UnaryParam< T >

Parameter handling for one dimensional unary function

### Intended use:

Internal

### Review Status

Test programs:
  tFunctionHolder

### Prerequisite

- FunctionParam class
- Function class

### Etymology

A 1-dimensional unary hat.

### Synopsis

A Unary is described by a height, a center and a width (halfwidth). The value is:

height (|x-center| < width)
0.5height (|x-center| == width)
0 (|x-center| > width)

The parameters are enumerated by HEIGHT, CENTER and WIDTH. They have default values of (1, 0, 1).

### Example

UnaryFunction<Double> sf(5.0, 25.0, 7);
sf(25); // = 5.0
casacore::UnaryFunction
Definition UnaryFunction.h:85

### Template Type Argument Requirements (T)

- T should have standard numerical operators

### Thrown Exceptions

- AipsError if incorrect parameter number specified.

Definition at line 83 of file UnaryParam.h.

## Member Enumeration Documentation

## anonymous enum

template<class T>

anonymous enum

Parameter numbers.

Enumerator
HEIGHT |
CENTER |
WIDTH |

Definition at line 88 of file UnaryParam.h.

## Constructor & Destructor Documentation

## UnaryParam() [1/6]

template<class T>

casacore::UnaryParam< T >::UnaryParam | ( |  | ) |

Constructs the Unary, Defaults: height=1, center=0, width=1.

Warning: Could not use default arguments that worked both with gcc and IRIX

Referenced by operator=(), casacore::UnaryFunction< T >::UnaryFunction(), casacore::UnaryFunction< T >::UnaryFunction(), casacore::UnaryFunction< T >::UnaryFunction(), casacore::UnaryFunction< T >::UnaryFunction(), casacore::UnaryFunction< T >::UnaryFunction(), casacore::UnaryFunction< T >::UnaryFunction(), UnaryParam(), and UnaryParam().

## UnaryParam() [2/6]

template<class T>

casacore::UnaryParam< T >::UnaryParam | ( | const T & | height | ) |

explicit

## UnaryParam() [3/6]

template<class T>

casacore::UnaryParam< T >::UnaryParam | ( | const T & | height,
|  | const T & | center )

## UnaryParam() [4/6]

template<class T>

casacore::UnaryParam< T >::UnaryParam | ( | const T & | height,
|  | const T & | center,
|  | const T & | width )

## UnaryParam() [5/6]

template<class T>

casacore::UnaryParam< T >::UnaryParam | ( | const UnaryParam< T > & | other | ) |

Copy constructor (deep copy).

References UnaryParam().

## UnaryParam() [6/6]

template<class T>
template<class W>

casacore::UnaryParam< T >::UnaryParam | ( | const UnaryParam< W > & | other | ) |

inline

Definition at line 106 of file UnaryParam.h.

References casacore::Function< T, U >::Function(), and UnaryParam().

## ~UnaryParam()

template<class T>

virtual casacore::UnaryParam< T >::~UnaryParam | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## name()

template<class T>

virtual const String & casacore::UnaryParam< T >::name | ( |  | ) | const

inline virtual

Give name of function.

Reimplemented from casacore::Function< T, U >.

Definition at line 121 of file UnaryParam.h.

## ndim()

template<class T>

virtual uInt casacore::UnaryParam< T >::ndim | ( |  | ) | const

inline virtual

Returns the number of dimensions of function.

Implements casacore::Function< T, U >.

Definition at line 117 of file UnaryParam.h.

## operator=()

template<class T>

UnaryParam< T > & casacore::UnaryParam< T >::operator= | ( | const UnaryParam< T > & | other | ) |

Copy assignment (deep copy).

References UnaryParam().

Referenced by casacore::UnaryFunction< T >::operator=().

The documentation for this class was generated from the following file:

- scimath/Functionals/UnaryParam.h